config/routes.rb
Pc::Application.routes.draw do
  resources :ads

end

app/models/ad.rb
class Ad < ActiveRecord::Base
  has_many :photos, :dependent => :destroy

  accepts_nested_attributes_for :photos, :allow_destroy => true
end

app/models/photo.rb
require "lib/paperclip_processors/watermark"

class Photo < ActiveRecord::Base
  belongs_to :ad

  has_attached_file :data,
:styles => {
  :thumb => "100x100#",
  :first => {
    :processors => [:watermark, :thumbnail],
    :geometry => '300x250>',
    :watermark_path => Rails.root.join('public/images/watermark.png'),
    :position => 'SouthWest' },
  :large => {
    :processors => [:watermark, :thumbnail],
    :geometry => '640x480>',
    :watermark_path => Rails.root.join('public/images/watermark.png'),
    :position => 'SouthEast' }
}
end

app/controllers/ads_controller.rb
class AdsController < ApplicationController
  # GET /ads
  # GET /ads.xml
  def index
    @ads = Ad.all

    respond_to do |format|
      format.html # index.html.erb
      format.xml  { render :xml => @ads }
    end
  end

  # GET /ads/1
  # GET /ads/1.xml
  def show
    @ad = Ad.find(params[:id])

    respond_to do |format|
      format.html # show.html.erb
      format.xml  { render :xml => @ad }
    end
  end

  # GET /ads/new
  # GET /ads/new.xml
  def new
    @ad = Ad.new
    4.times { @ad.photos.build }

    respond_to do |format|
      format.html # new.html.erb
      format.xml  { render :xml => @ad }
    end
  end

  # GET /ads/1/edit
  def edit
    @ad = Ad.find(params[:id])
  end

  # POST /ads
  # POST /ads.xml
  def create
    @ad = Ad.new(params[:ad])

    respond_to do |format|
      if @ad.save
        format.html { redirect_to(@ad, :notice => 'Ad was successfully created.') }
        format.xml  { render :xml => @ad, :status => :created, :location => @ad }
      else
        format.html { render :action => "new" }
        format.xml  { render :xml => @ad.errors, :status => :unprocessable_entity }
      end
    end
  end

  # PUT /ads/1
  # PUT /ads/1.xml
  def update
    @ad = Ad.find(params[:id])

    respond_to do |format|
      if @ad.update_attributes(params[:ad])
        format.html { redirect_to(@ad, :notice => 'Ad was successfully updated.') }
        format.xml  { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml  { render :xml => @ad.errors, :status => :unprocessable_entity }
      end
    end
  end

  # DELETE /ads/1
  # DELETE /ads/1.xml
  def destroy
    @ad = Ad.find(params[:id])
    @ad.destroy

    respond_to do |format|
      format.html { redirect_to(ads_url) }
      format.xml  { head :ok }
    end
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  protect_from_forgery
end

app/helpers/ads_helper.rb
module AdsHelper
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/ads/_form.html.erb
<%= form_for(@ad, :html => {:multipart => true}) do |f| %>
  <% f.fields_for :photos do |p| %>
    <p>
      <%= p.label :data, 'Poza:' %> <%= p.file_field :data %>
    </p>
  <% end %>
  <% if @ad.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@ad.errors.count, "error") %> prohibited this ad from being saved:</h2>

      <ul>
      <% @ad.errors.full_messages.each do |msg| %>
        <li><%= msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/ads/edit.html.erb
<h1>Editing ad</h1>

<%= render 'form' %>

<%= link_to 'Show', @ad %> |
<%= link_to 'Back', ads_path %>

app/views/ads/index.html.erb
<h1>Listing ads</h1>

<table>
  <tr>
    <th></th>
    <th></th>
    <th></th>
  </tr>

<% @ads.each do |ad| %>
  <tr>
    <td><%= link_to 'Show', ad %></td>
    <td><%= link_to 'Edit', edit_ad_path(ad) %></td>
    <td><%= link_to 'Destroy', ad, :confirm => 'Are you sure?', :method => :delete %></td>
  </tr>
<% end %>
</table>

<br />

<%= link_to 'New Ad', new_ad_path %>

app/views/ads/new.html.erb
<h1>New ad</h1>

<%= render 'form' %>

<%= link_to 'Back', ads_path %>

app/views/ads/show.html.erb
<p id="notice"><%= notice %></p>

<% @ad.photos.each do |photo| %>
  <p>
    <%= image_tag photo.data.url(:first) %>
  </p>
<% end %>
<%= link_to 'Edit', edit_ad_path(@ad) %> |
<%= link_to 'Back', ads_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Pc</title>
  <%= stylesheet_link_tag :all %>
  <%= javascript_include_tag :defaults %>
  <%= csrf_meta_tag %>
</head>
<body>

<%= yield %>

</body>
</html>